//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    Blue
#property indicator_color2    Red
#property indicator_style2    STYLE_SOLID
#property indicator_width1    2
#property indicator_minimum  -5
#property indicator_maximum 105
#property indicator_level1   50
#property indicator_level2   50
#property indicator_levelcolor Yellow

//
//
//
//
//

extern int                MaPeriod               = 5;
extern ENUM_MA_METHOD     MaMethod               = MODE_SMMA;
extern ENUM_APPLIED_PRICE MaPrice                = PRICE_CLOSE;
extern int                StochasticPeriod       = 5;
extern int                StochasticSignalPeriod = 2;
extern bool               verticalLinesVisible   = false;
extern string             verticalLinesID        = "stoma Lines";
extern color              verticalLinesUpColor   = DeepSkyBlue;
extern color              verticalLinesDnColor   = PaleVioletRed;
extern color              verticalLinesNuColor   = DimGray;
extern int                verticalLinesStyle     = STYLE_SOLID;
extern int                verticalLinesWidth     = 2;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,trend);
      IndicatorShortName("Stochastic of MA ("+MaPeriod+")");
   return(0);
}
int deinit() 
{  
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //

   double alpha = 2.0 / (1.0 + StochasticSignalPeriod);
   for(int i=limit; i>=0; i--)
   {
      buffer3[i] = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i);
      
      //
      //
      //
      //
      //
      
      double hi = buffer3[ArrayMaximum(buffer3,StochasticPeriod,i)];
      double lo = buffer3[ArrayMinimum(buffer3,StochasticPeriod,i)];
      if (hi != lo)
            buffer1[i] = 100*(buffer3[i]-lo)/(hi-lo);
      else  buffer1[i] = 0.00;
      if (StochasticSignalPeriod>1) buffer2[i] = buffer2[i+1] + alpha*(buffer1[i]-buffer2[i+1]);
      
      //
      //
      //
      //
      //
      
      trend[i] = trend[i+1];
      if (buffer1[i]>50) trend[i] = 1;
      if (buffer1[i]<50) trend[i] =-1;   
      
      //
      //
      //
      //
      //
      
      if (verticalLinesVisible )
      {
         ObjectDelete(verticalLinesID+":"+Time[i]);
         if (trend[i]!= trend[i+1])
         {
            if (trend[i] == 1) drawLine(i,verticalLinesUpColor);
            if (trend[i] ==-1) drawLine(i,verticalLinesDnColor);
         }
      }
   }         
return(0);
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
     string name = verticalLinesID+":"+Time[i];
   
     //
     //
     //
     //
     //
     

     ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
        ObjectSet(name,OBJPROP_COLOR,theColor);
        ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
        ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
        ObjectSet(name,OBJPROP_BACK,true);
}